<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title> MobiDoc | Profile </title>
    <link rel="stylesheet" href="styles/Nav_bar.css">
    <link rel="stylesheet" href="styles/profile,.css">

    <link rel="apple-touch-icon" sizes="180x180" href="../favicon/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="../favicon/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="../favicon/favicon-16x16.png">
    <link rel="manifest" href="../favicon/site.webmanifest">

    <!-- The core Firebase JS SDK is always required and must be listed first -->
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-auth.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-database.js"></script>

</head>
<body onload="Test()">

<!--Nav Bar Stuff-->
<div class="wrapper">
    <nav>
        <input type="checkbox" id="show-search">
        <input type="checkbox" id="show-menu">
        <label for="show-menu" class="menu-icon"><i class="fas fa-bars"></i></label>
        <div class="content">
            <div class="logo"><a href="#">MobiDoc</a></div>
            <ul class="links">
                <li><a href="home.html">Home</a></li>
                <li>
                    <a href="profile.html" class="desktop-link">Profile</a>
                    <input type="checkbox" id="show-services">
                    <label for="show-services">Profile</label>
                </li>
                <li><a href="Appointments.html">Accept Appointments</a></li>
                <li><a href="AppointmentTypes/PendingAppointments.html">Reject Appointments</a></li>
                <li><a href="consultations.html">Complete Appointment</a></li>
                <li>
                    <a href="#" class="desktop-link" style="padding-left: 50px">Appointments</a>
                    <input type="checkbox" id="show-features">
                    <label for="show-features">Appointments</label>
                    <ul>
                        <li><a style="padding-left: 60px" href="AppointmentTypes/RejectedAppointments.html">Rejected Appointments</a></li>
                        <li><a style="padding-left: 60px" href="AppointmentTypes/PendingAppointments.html">Pending Appointments</a></li>
                        <li><a style="padding-left: 60px" href="AppointmentTypes/CompletedAppointments.html">Completed Appointments</a></li>
                    </ul>
                </li>
            </ul>
        </div>
    </nav>
</div>

<div style="padding-bottom: 200px"></div>

<!--Profile Stuff-->
<div class="container"  id="profile">
    <div class="contact-box">
        <div class="left">
        </div>
        <div class="right">
            <h2 id ="Name" >Name Surname</h2>
            <p id = "email"> Email Address </p>

            <table>
                <tr>
                    <th>Experience</th>
                    <td id = "experience"></td>
                </tr>
                <tr>
                    <th>Specialization</th>
                    <td id = "specialization"></td>
                </tr>
                <tr>
                    <th>Qualifications</th>
                    <td id = "qualification"></td>
                </tr>

            </table>

            <button id="btn_edit" onclick="ChangeView()"> Edit Profile </button>
        </div>
    </div>
</div>

<!--Edit Profile -->
<!--Profile Stuff-->
<div class="container" id = "edit_profile" style="display: none">
    <div class="contact-box">
        <div class="left">
        </div>
        <div class="right">
            <h2>Edit Your Profile</h2>
            <p> You may leave fields blank  </p>
            <br/>
            <input id = "e_fname" type="text" class="field" placeholder="First Name">
            <input id = "e_lname" type="text" class="field" placeholder="Last Name">
            <input id = "e_exp" type="number" class="field" placeholder="Experience">
            <input id = "e_ql" type="text" class="field" placeholder="Qualifications">
            <input id = "e_spec" type="text" class="field" placeholder="Specialization">
            <br/>
            <button onclick="SendUpdatedInformationToFirebase()"> Update </button>
            <div id = "spinner" class="lds-roller" style="display: none"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
            <br/>
            <p id="note"></p>
            <br/>
            <button onclick="ReturnToProfile()"> Return to Profile </button>
        </div>
    </div>
</div>


<script>

    var firebaseConfig = {
        apiKey: "AIzaSyB-ckD1wmZWj5c7RQIOyBvwFmQApBfEEMU",
        authDomain: "mobidoc-6a3ac.firebaseapp.com",
        databaseURL: "https://mobidoc-6a3ac-default-rtdb.firebaseio.com/",
        projectId: "mobidoc-6a3ac",
        storageBucket: "mobidoc-6a3ac.appspot.com",
        messagingSenderId: "311373483549",
        appId: "1:311373483549:web:3c840b29b14029ac4680f4",
        measurementId: "G-JFPKMPTGZ5"
    };
    // Initialize Firebase
    firebase.initializeApp(firebaseConfig);

</script>


</body>
<script  src="./scripts/profile.js"></script>
<script>
    const UpDateInformation = (uid,value,key) => {
        let database = firebase.database();
        let ref = database.ref().child('Doctors');
        switch (key) {
            case "first_name":
                ref.child(uid).update({"first_name":value});
                break;
            case "last_name":
                ref.child(uid).update({"last_name":value});
                break;
            case "experience":
                ref.child(uid).update({"experience":value});
                break;
            case "qualifications":
                ref.child(uid).update({"qualifications":value});
                break;
            case "specialization":
                ref.child(uid).update({"specialization":value});
                break;
        }
    }

    let User_uid;

    function Test() {
        firebase.auth().onAuthStateChanged(function (user) {
            if (user) {
                UpdateDetails(user.uid);
                User_uid = user.uid;
            } else {
                window.location.href = "../index.html"; // redirects the user to the log in page
            }
        });
    }


    const UpdateDetails = (uid) => {
        let database = firebase.database();
        let ref = database.ref().child('Doctors');
        // t0 = performance.now();
        ref.on("value",snapshot => {
               if (snapshot.exists()) {
                   snapshot.forEach(function (childSnapshot) {
                       let Doctor = childSnapshot.val();
                       if(Doctor.uid === uid) {
                                SetDataFromFirebase(Doctor);
                       }
                   });
               }
            //
            // var t1 = performance.now()
            // console.log(((t1-t0) % 60000) / 1000);
        });

    }


    function CheckIfEdited(value,key){
        if(ValidateDetails(value)){
            UpDateInformation(User_uid,value,key);
        }
    }

    function SendUpdatedInformationToFirebase(){

        let e_fname = document.getElementById("e_fname").value;
        let e_lname = document.getElementById("e_lname").value;
        let e_Exp = document.getElementById("e_exp").value;
        let e_QL = document.getElementById("e_ql").value;
        let e_Spec = document.getElementById("e_spec").value;

        CheckIfEdited(e_fname,"first_name");
        CheckIfEdited(e_lname,"last_name");
        CheckIfEdited(e_Exp,"experience");
        CheckIfEdited(e_QL,"qualifications");
        CheckIfEdited(e_Spec,"specialization");

        Toast();

    }

    function sleep(ms) {
        return new Promise(resolve => setTimeout(resolve, ms));
    }

    async function Toast(){
        document.getElementById("note").innerText = "updating your information ...";
        document.getElementById("spinner").style.display = "block";
        await sleep(2000);
        document.getElementById("spinner").style.display = "none";
        document.getElementById("note").innerHTML = "<br/>" + "Information updated successfully. Please refresh the page";
    }


</script>

</html>